#ifndef __CUI_H__
#define __CUI_H__

#define CUI_DRAW_NORMAL		0
#define CUI_DRAW_FOCUS		1
#define CUI_DRAW_ACTIVE		2

typedef struct cui_base *cui;

#define MSG(s) fprintf(stderr, "%s() %s L%d : %s\n", __func__, __FILE__, __LINE__, s)
#define ERR(s) do{ fprintf(stderr, "ERR "); MSG(s); exit(1); }while(0)

#define FALSE	0
#define TRUE	1

#define CUI_EVT_KEY		(1<<0)
#define CUI_EVT_DRAW		(1<<1)
#define CUI_EVT_BUTTON		(1<<2)

#define CUI_FLG_CAN_FOCUS	(1<<0)

typedef struct cui_handler_list *cui_handler_list;

struct cui_base{
	cui parent, children, next;
	int x, y, w, h;
	cui_handler_list handler_list;
	int flags;
};	

cui cui_alloc(int size);
void cui_base_init(cui obj, cui parent, int x, int y, int w, int h);
void cui_base_child_add(cui obj, cui child);

void cui_draw_str(cui obj, int x, int y, char *s, int attr);

int cui_gx(cui obj);
int cui_gy(cui obj);
void cui_draw(cui obj);
void cui_quit(void);
void cui_main(cui top_obj);
void cui_free(cui obj);

char *cui_simple_dialog(int x, int y, char *s, char *s_btn1, char *s_btn2);

#endif
