#include "esc.h"

#include <stdio.h>

void
cui_esc(char *s)
{
	printf("\033[%s", s);
	fflush(stdout);
}

void
cui_esc_cls(void)
{
	cui_esc("2J");
}

void
cui_esc_loc(int x, int y)
{
	char buf[16];

	sprintf(buf, "%d;%dH", y+1, x+1);
	cui_esc(buf);
}

void
cui_esc_attr(int attr)
{
	char buf[16];

	sprintf(buf, "%dm", attr);
	cui_esc(buf);
}

void
cui_esc_cursor_pos_save(void)
{
	cui_esc("s");
}

void
cui_esc_cursor_pos_load(void)
{
	cui_esc("u");
}

void
cui_esc_exopt(int n, int onoff)
{
	char buf[16];

	sprintf(buf, "?%d%c", n, onoff ? 'h' : 'l');
	cui_esc(buf);
}

void
cui_esc_cursor(int onoff)
{
	cui_esc(onoff ? "?25h" : "?25l");
}

void
cui_esc_enter(void)
{
	cui_esc_cursor_pos_save();
	cui_esc_exopt(CUI_ESC_SCREEN_SAVE_LOAD, 1);
	cui_esc_exopt(CUI_ESC_CURSOR_ONOFF, 0);
}

void
cui_esc_exit(void)
{
	cui_esc_attr(CUI_ESC_NORMAL);
	cui_esc_exopt(CUI_ESC_CURSOR_ONOFF, 1);
	cui_esc_exopt(CUI_ESC_SCREEN_SAVE_LOAD, 0);
	cui_esc_cursor_pos_load();
}

/* EOF */
